require 'sketchup.rb'
require 'extensions.rb'
require 'langhandler.rb'

module Shink
  module SkModelBox
    PluginName = 'sk_model_box'
    Version = '1.2.0'.freeze

    Object.send(:remove_const, 'RGLoader') if Object.const_defined?('RGLoader')

    lh = LanguageHandler.new("#{PluginName}.strings")
    if RUBY_VERSION.split('.')[0].to_i > 2
      load_path = File.join(File.dirname(__FILE__), PluginName, 'v3', 'load')
    else
      load_path = File.join(File.dirname(__FILE__), PluginName, 'v2', 'load')
    end
    extension = SketchupExtension.new(lh['插件名称'], load_path)
    extension.version = Version
    extension.creator = lh['插件作者']
    extension.description = lh['插件说明']
    Sketchup.register_extension(extension, true)
  end
end
